%global momorel 2
%global hg_version 5960
%global srcname %{name}-%{hg_version}
%global emacsver 23.2
%global e_sitedir %{_datadir}/emacs/site-lisp
%global __spec_install_post /usr/lib/rpm/brp-compress

Summary: The Go Programming Language
Name: golang
%{?include_specopt}
%{?!do_test: %global do_test 1}

Version: 0.0.%{hg_version}
Release: %{momorel}m%{?dist}
License: Modified BSD
Group: Development/Languages

Source0: %{srcname}.tar.xz
# made by
# hg clone -r release https://go.googlecode.com/hg/ $GOROOT
# and archvie

Patch0: notest.patch

BuildRequires: gcc emacs >= %{emacsver}
ExclusiveArch: noarch %{ix86} x86_64 arm
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
URL: http://golang.org/

%description
Go is simple, fast, safe, concurrent, fun, open source language

go lang is not installed in $HOME, so you need set some environment
variables: GOROOT, GOBIN, GOARCH, and GOOS.
Please write in .bashrc below.

 export GOROOT=/usr/{lib|lib64}/go
 export GOBIN=/usr/bin
 export GOARCH={386|amd64}
 export GOOS=linux

%package -n emacs-go-mode
Summary: An Emacs major mode for editing Go source text
Group: Applications/Editors
Requires: emacs >= %{emacsver}

%description -n emacs-go-mode
Go-mode is a major mode for editing Go source text.

%prep
%setup -q -n go

%if ! %{do_test}
%patch0 -p1
%endif %% ! %%{do_test}

%build
rm -rf --preserve-root %{buildroot}
mkdir -p %{buildroot}%{_bindir}

export GOROOT=$(pwd)
export GOOS=linux
export GOBIN=%{buildroot}%{_bindir}
export PATH="$PATH:%{buildroot}%{_bindir}"
%ifarch %{ix86}
export GOARCH=386
%endif
%ifarch x86_64
export GOARCH=amd64
%endif
%ifarch arm
export GOARCH=arm
%endif

# for main package
pushd src
make build
make run
popd

# for draw package
pushd src/pkg/exp/draw
make; make install
popd

# for x11 package
pushd src/pkg/exp/draw/x11
make; make install
popd

# for document
pushd doc
make; make install
popd

# for emacs
emacs -batch -q -no-site-file -f batch-byte-compile misc/emacs/go-mode.el

%install
# for emacs-lisp
mkdir -p %{buildroot}%{e_sitedir}
install -m 644 misc/emacs/go-mode-load.el %{buildroot}%{e_sitedir}
install -m 644 misc/emacs/go-mode.el* %{buildroot}%{e_sitedir}

# for runtime
mkdir -p %{buildroot}%{_libdir}/go
cp -ar pkg %{buildroot}%{_libdir}/go

# for document
cp -ar lib %{buildroot}%{_libdir}/go
cp -ar src %{buildroot}%{_libdir}/go
find %{buildroot}%{_libdir}/go/src -type f | grep -v "\.go$" | xargs rm
cp -ar doc %{buildroot}%{_libdir}/go

%clean
rm -rf --preserve-root %{buildroot}

%files
%defattr(-,root,root,-)
%doc doc README LICENSE CONTRIBUTORS AUTHORS
%{_bindir}/?cov
%{_bindir}/?nm
%{_bindir}/?prof
%{_bindir}/cgo
%{_bindir}/ebnflint
%{_bindir}/godefs
%{_bindir}/godoc
%{_bindir}/gofmt
%{_bindir}/gomake
%{_bindir}/gopack
%{_bindir}/gotest
%{_bindir}/goyacc
%{_bindir}/hgpatch
%{_bindir}/htmlgen
%{_bindir}/quietgcc

%{_libdir}/go

%ifarch %{ix86}
%{_bindir}/8a
%{_bindir}/8c
%{_bindir}/8g
%{_bindir}/8l
%endif

%ifarch x86_64
%{_bindir}/6a
%{_bindir}/6c
%{_bindir}/6g
%{_bindir}/6l
%endif

%files -n emacs-go-mode
%defattr(-,root,root,-)
%{e_sitedir}/go-mode-load.el
%{e_sitedir}/go-mode.el*

%changelog
* Tue Aug 31 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.5960-2m)
- full rebuild for mo7 release

* Mon Aug  9 2010 Yohsuke Ooi <meke@momonga-linux.org> 
- (0.0.5960-1m)
- update go-rev5960

* Sun Jun 13 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.0.4592-2m)
- rebuild against emacs-23.2

* Wed Jan 13 2010 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.0.4592-1m)
- update
- set specopt "do_test"

* Wed Jan 13 2010 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.0.4531-5m)
- add Patch0

* Sun Jan 10 2010 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.0.4531-4m)
- enable godoc -http=:port

* Sun Jan 10 2010 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.0.4531-3m)
- delete unused binary files for godoc

* Sun Jan 10 2010 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.0.4531-2m)
- enable godoc

* Sun Jan 10 2010 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.0.4531-1m)
- update to 4531
- please read rpm -qi golang ;-)

* Sat Jan  9 2010 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.0.4564-1m)
- version up

* Thu Jan  7 2010 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.0.4542-1m)
- version up

* Tue Dec 29 2009 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.0.4506-1m)
- version up

* Sat Dec 26 2009 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.0.4493-1m)
- version up

* Thu Dec 24 2009 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.0.4491-1m)
- version up

* Thu Dec 24 2009 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.0.4489-1m)
- version up

* Thu Dec 24 2009 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.0.4481-1m)
- roll back 4481
- use export instead of env

* Thu Dec 24 2009 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.0.4489-1m)
- version up

* Wed Dec 23 2009 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.0.4481-1m)
- version up
- do not strip, strip makes gofmt SEGV

* Tue Dec  1 2009 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.0.4250-1m)
- version up

* Sat Nov 14 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.0.4008-3m)
- rebuild against gcc-4.4 and glibc-2.11

* Thu Nov 12 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.0.4008-2m)
- BuildRequires: gcc emacs
- create emacs-go-mode package

* Thu Nov 12 2009 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.0.4008-1m)
- version up

* Wed Nov 11 2009 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.0.3975-1m)
- initial spec file for Momonga Linux from mgzip.spec
